#include <stdio.h>
#include <stdlib.h>
#include <sqlite3.h>


#include <unistd.h>  
#include <termios.h>

#include <ctype.h>

int  Nrecord,Nactual;

sqlite3 *db;  /* Puntero a la base de datos */
sqlite3_stmt *resultado;    /* Puntero a los resultados de las consultas */
int msg;    /* Valor de retorno para las instrucciones */
char* error;    /* Mensaje de error de una orden */

char  NombreDB[]="libros.sqlite";

void BuscarAutor(void);
void BuscarIdAutor(void);
void BuscarMas(void);
void ListarRegitro(void);

char VARI[80]; 

static struct termios old, new;


int FnumRecord(void *NotUsed, int argc, char **argv,   char **azColName) 
{    
    NotUsed = 0;
    if( argv[0]) 
		Nrecord=atoi( argv[0]);
	else
		Nrecord=-1;
//    printf("Para=%s    FnumeroRecord=%d\n",azColName[0],Nrecord);
    return 0;
}



//_________________________________________________________ 
void initTermios(int echo) 
{
  tcgetattr(0, &old); /* grab old terminal i/o settings */
  new = old; /* make new settings same as old settings */
  new.c_lflag &= ~ICANON; /* disable buffered i/o */
  if (echo) {
      new.c_lflag |= ECHO; /* set echo mode */
  } else {
      new.c_lflag &= ~ECHO; /* set no echo mode */
  }
  tcsetattr(0, TCSANOW, &new); /* use these new terminal i/o settings now */
}

/* Restore old terminal i/o settings */
void resetTermios(void) 
{
  tcsetattr(0, TCSANOW, &old);
}

/* Read 1 character - echo defines echo mode */
char getCaracter(int echo) 
{
  char ch;
  initTermios(echo);
  ch = getchar();
  resetTermios();
  return ch;
}
//___________________________________________________



void MiMenu(void)
{
		printf("\n______MENU___________TOTAL_REGISTROS=%d \n",Nrecord);
		printf("1-.Buscar por autor \n");
		printf("2-.Buscar por IdAutor \n");
		printf("3-.listar desde registro \n");
		printf("+-.Lista 10 registro mas \n");
		printf("Q-.Salir\n");	
		printf("-------------------------\n");		
}	

int main()
{
 char c;

	system("clear");
 
	printf("SETA43   http://seta43.blogspot.com\n");	
    printf("Version %s\n", sqlite3_libversion());
   // printf ("SQLITE LIB Version (int): %d\n", sqlite3_libversion_number());
    msg = sqlite3_open(NombreDB,&db);
    if (msg!=SQLITE_OK) 
		{ printf("Error al abrir la base de datos\n"); }
		else
		{ printf("OK en apertura de la base de datos  %s\n",NombreDB); }
	msg = sqlite3_prepare(db, "Select * from Autores", -1, &resultado, 0); 
	msg = sqlite3_exec(db, "Select count(*) from Autores", FnumRecord, 0, &error);
	printf("Numero de registros=%d\n",Nrecord);
	
	MiMenu();
	
	while(c!='q' && c!='Q')
	{	
		switch(c)
		{
		 case '1':
			system("clear"); BuscarAutor(); MiMenu();
		 break;
		
		 case '2':
			system("clear"); BuscarIdAutor(); MiMenu();
		 break;
		 
		 case '3':
			system("clear"); ListarRegitro(); MiMenu();
		 break;	
		 case '+':
			system("clear"); BuscarMas(); MiMenu();
		 break;	
		}
		c = getCaracter(0);
	}
	printf(" Fin de programa  \n\n");
}

void ListarRegitro(void)
{
 int z,zz;
 
  Nactual=0;
  msg = sqlite3_exec(db, "Select count(*) from Autores", FnumRecord, 0, &error);
  msg = sqlite3_prepare(db, "Select * from Autores", -1, &resultado, 0); 

  printf("Total registros=%d\n",Nrecord);	  
  printf("Numero de registro=");
  scanf("%s",VARI);
  system("clear");
  zz=atoi(VARI);
  zz--; if(zz<0)zz=0;
  for(z=1;z<Nrecord && Nactual<zz;z++, Nactual++)
	{
	 msg = sqlite3_step(resultado);		
	}
  	
  BuscarMas();
}

void BuscarIdAutor(void)
{
	char ordenSQL[256];
	int z;
 
	printf("IdAutor=");
	scanf("%s",VARI);
	system("clear");
	Nactual=0;
	
	sprintf(ordenSQL,"SELECT count(*) FROM Autores  where   IdAutor = %s",VARI);
	//printf("____%s_____\n",ordenSQL);
	msg = sqlite3_exec(db, ordenSQL, FnumRecord, 0, &error);
	if (msg!=SQLITE_OK)  { printf("Error  from Autores where autor\n"); }
	
	sprintf(ordenSQL,"SELECT * FROM Autores  where   IdAutor = %s",VARI);
	//printf("____%s_____\n",ordenSQL);
	msg = sqlite3_prepare(db, ordenSQL, -1, &resultado, 0);  	
    if (msg!=SQLITE_OK)  { printf("Error  from IdAutor where autor\n"); }		
		
	BuscarMas();
}


void BuscarMas(void)
{
  int z;
	if(Nactual>Nrecord) return;
	 printf("*%d_____RESULTADOS DE LA BUSQUEDA=%s______\n",Nrecord,VARI);
	for(z=0;z<10;z++)
	{
	 msg = sqlite3_step(resultado);	
	 Nactual++;
	 if (msg == SQLITE_ROW) 
	  { 
	  printf(">%03d>>>>%06s",Nactual, sqlite3_column_text(resultado, 0));  
	  printf("     %05s", sqlite3_column_text(resultado, 1)); 
	  printf("     %03s", sqlite3_column_text(resultado, 2)); 
	  printf("     %s", sqlite3_column_text(resultado, 3));
	  printf("     %s", sqlite3_column_text(resultado, 4));
	  printf("     %s\n", sqlite3_column_text(resultado, 5));
	  } 
	 else
	  {printf("\n**************____Fin de listado___****************\n"); return;}
	}	
	printf( "___EXISTEN_MAS 10_____pulsa +___\n");
}

void BuscarAutor(void)
{
 char ordenSQL[256];
 int z;
	
	Nactual=0;
	
	printf("AUTOR=");
	scanf("%s",VARI);
	system("clear");
	for(z = 0; VARI[z]; z++)    VARI[z] = toupper(VARI[z]);
	sprintf(ordenSQL,"SELECT count(*) FROM Autores  where   autor  LIKE '%%%s%%'",VARI);
//	printf("____%s_____\n",ordenSQL);
	msg = sqlite3_exec(db, ordenSQL, FnumRecord, 0, &error);
	if (msg!=SQLITE_OK)  { printf("Error  from Autores where autor\n"); }
	
	sprintf(ordenSQL,"SELECT * FROM Autores  where   autor  LIKE '%%%s%%'",VARI);
//	printf("____%s_____\n",ordenSQL);
	msg = sqlite3_prepare(db, ordenSQL, -1, &resultado, 0);  	
    if (msg!=SQLITE_OK)  { printf("Error  from Autores where autor\n"); }
	
	BuscarMas();
}
